/* _BUFIN.C--
 * Copyright (c) 2001 Hjort Nidudsson
 *
 * Change history:
 * 30 Oct 2008	- Added switch -scsDOS to 7-zip config (@list)
 * 25 Aug 2001	- Init Data to _bufin
 */

#define LF	"\r\n"

char _bufin[576] =
"Command line switches"							LF
" The following switches may be used in the command line:"		LF
									LF
"  -T (tiny)  - read maximum 500 files in each panel"              	LF
"  -L (large) - read maximum 5000 files in each panel"              	LF
"     default is 3000."                                         	LF
									LF
"  -XP (WinXP)     - trigger a mode change on startup"                 	LF
"  -V (verbose)    - print DOS return code (errorlevel)"		LF
"  -C<config_path> - Read/Write setup from/to <config_path>"		LF
									LF
"  DZ <filename> command starts DZ and forces it to show <filename>"    LF
"contents if it is an archive or show folder contents if <filename>"    LF
"is a folder."                                                          LF
;

char cp_termination[128] =
"**Error** running %s:"	LF
"Termination type: %s"  LF
"DOS return code:  %d"  LF;
char cp_system_error[64] =
"System error message: ";
char cp_termination_type[4][64] = {
	"Normal",
	"Control-C abort",
	"Critical error abort",
	"Terminate and stay resident"
};

char cp_ercomspec[64] =
"Error loading COMMAND.COM.."						LF
									LF
;

char default_ini[2048+960] =
"; DZ.INI - DOSZIP Configuration file"					LF
";"                                                                     LF
"; This file contains all the variables that \"customize\""		LF
"; DOSZIP to your particular needs."                                    LF
";"                                                                     LF
"; The entries have the following format:"                              LF
";"                                                                     LF
"; [<Section name>]"                                                    LF
"; <Entry name>=<properties>"                                           LF
";"                                                                     LF
"; Space and tabs may appear before or after the equal sign."           LF
";"                                                                     LF
"; Last Updated: 30 Oct 2008"                                           LF
";"                                                                     LF
									LF
"[View]"                                                                LF
"F3      = ; You can override the internal viewer by redefine F3"       LF
"Alt     = ; Viewer for Alt+F3"                                         LF
"Ctrl    = ; Viewer for Ctrl+F3"                                        LF
"Shift   = ; Viewer for Shift+F3"                                       LF
									LF
"[Edit]"                                                                LF
"F4      = EDIT"                                                        LF
"Alt     = NOTEPAD ; Editor for Alt+F4"                                 LF
"Ctrl    = ; Editor for Ctrl+F4"                                        LF
"Shift   = ; Editor for Shift+F4"                                       LF
									LF
"[Filetype] ; This assumes the Borland tools is in the PATH"	    	LF
"asm=bc     ; Borland C++"                                              LF
"c=bc"                                                                  LF
"h=bc"                                                                  LF
"inc=bc"                                                                LF
"mak=make -f!"                                                          LF
"makefile=make"                                                         LF
"prj=bc"                                                                LF
"txt=bc"								LF
									LF
"[Directory] ; Directories for Ctrl-[0..9]"                             LF
"00=Doszip &Directory          Ctrl-0, %DOSZIP%"			LF
"01=Doszip &Source Directory   Ctrl-1, %DOSZIP%\\src"			LF
"02=System &Root               Ctrl-2, %SYSTEMROOT%"			LF
"03=&Program Files             Ctrl-3, %PROGRAMFILES%"			LF
"04=&Common Program Files      Ctrl-4, %COMMONPROGRAMFILES%"		LF
"05=&Application Data          Ctrl-5, %APPDATA%"			LF
"06=&Temp Directory            Ctrl-6, %TEMP%"				LF
"07=&Home Path                 Ctrl-7, %HOMEDRIVE%%HOMEPATH%"		LF
"08=&User Profile              Ctrl-8, %USERPROFILE%"			LF
"09=A&ll Users Profile         Ctrl-9, %ALLUSERSPROFILE%"		LF
"10=<>"				                 			LF
"11=L&ogon Server...,                  %LOGONSERVER%"			LF
									LF
"[Tools] ; Tools [0..9] use key Alt-[0..9]"                             LF
"00=&Add tool                   Alt-0, %EDIT% %DOSZIP%\\DZ.INI"		LF
"01=<>"				                 			LF
"02=&Doszip Commandline         Alt-2, %DOSZIP%\\dz -?"                 LF
"03=&View DZ.INI                Alt-3, %VIEW% %DOSZIP%\\DZ.INI"         LF
"04=View &README.TXT            Alt-4, %VIEW% %DOSZIP%\\README.TXT"     LF
									LF
"[Filter]"								LF
"00=&Executable, *.exe *.com *.bat"					LF
"01=&Compressed, *.lzh *.zoo *.zip *.arj *.pak *.arc *.7z *.bz2 *.tar"	LF
									LF
"[Packer]"								LF
"00=ZIP"								LF
"01=7Z"									LF
"02=TAR"								LF
"03=BZ2"								LF
"04=GZ"									LF
"05=ARJ"								LF
"06=ARC"								LF
"07=PAK"								LF
"08=LZH"								LF
"09=ZOO"								LF
									LF
"[ZIP]"									LF
"00=pkzip -u -wHS"							LF
"01=pkzip -u -P -wHS"							LF
"02=pkunzip -o"								LF
"03=pkunzip -o -d"							LF
"04=pkzip -d"								LF
"05=-ex"								LF
"06=-es"								LF
"07=-s"									LF
"09=@"									LF
"10=7za u -tzip -y"							LF
"11=7za u -tzip -y"							LF
"12=7za e -y"								LF
"13=7za x -y"								LF
"14=7za d -y"								LF
"15=-mx9"								LF
"16=-mx1"								LF
"17=-p"									LF
"18=-o"									LF
"19=-scsDOS @"								LF
									LF
"[7Z]"									LF
"10=7za u -y"								LF
"11=7za u -y"								LF
"12=7za e -y"								LF
"13=7za x -y"								LF
"17=-p"									LF
"18=-o"									LF
"19=-scsDOS @"								LF
									LF
"[TAR]"									LF
"10=7za u -ttar -y"							LF
"11=7za u -ttar -y"							LF
"12=7za e -y"								LF
"13=7za x -y"								LF
"17=-p"									LF
"18=-o"									LF
"19=-scsDOS @"								LF
									LF
"[BZ2]"									LF
"10=7za u -tbzip2 -y"							LF
"11=7za u -tbzip2 -y"							LF
"12=7za e -y"								LF
"13=7za x -y"								LF
"17=-p"									LF
"18=-o"									LF
"19=-scsDOS @"								LF
									LF
"[GZ]"									LF
"10=7za u -tgzip -y"							LF
"11=7za u -tgzip -y"							LF
"12=7za e -y"								LF
"13=7za x -y"								LF
"17=-p"									LF
"18=-o"									LF
"19=-scsDOS @"								LF
									LF
"[ARJ]"									LF
"00=arj u -y"								LF
"01=arj u -y"								LF
"02=arj e -y -e"							LF
"03=arj x -y"								LF
"05=-m4"								LF
"06=-m1"								LF
"07=-g"									LF
"09=!"									LF
									LF
"[ARC]"									LF
"00=arc a"								LF
"01=arc a"								LF
"02=arc eow"								LF
"03=arc xow"								LF
"09=@"									LF
									LF
"[PAK]"									LF
"00=pak u"								LF
"01=pak u"								LF
"02=pak e -wa"								LF
"03=pak e -i -wa" 							LF
"05=/C"									LF
"06=/CR"								LF
"09=@"									LF
									LF
"[LZH]"									LF
"00=lharc u -am"							LF
"01=lharc a -apm"							LF
"02=lharc e -m"								LF
"03=lharc e -m"								LF
									LF
"[ZOO]"									LF
"00=zoo -add"								LF
"01=zoo -add"								LF
"02=zoo -extract"							LF
"03=zoo -extract"							LF
"04=zoo -delete"							LF
"09=@"									LF
									LF
"%%EOF"                                                                 LF
; /* == end of _bufin */

